using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Content;
using TheWizard.Sprite;

namespace TheWizard
{
    class Enemy
    {

        Texture2D mEnemyTexture;

        Sprite.Sprite mEnemy;

        Dictionary<string, Sprite.Sprite> mEnemies = new Dictionary<string, global::TheWizard.Sprite.Sprite>();

        public Enemy(GraphicsDevice theDevice, ContentManager theLoader)
        {
            //Load the image into the texture object
            mEnemyTexture = theLoader.Load<Texture2D>("./Images/goomba") as Texture2D;
            mEnemy = new Sprite.Sprite(new Rectangle(420, 330, 50, 50), new Rectangle(6, 2, 44, 44));
            mEnemy.Visible = true;
        }//End Wizard(GraphicsDevice theDevice)

        public void Update(double elapsed)
        {
            UpdateEnemy(elapsed);
        }//End Update

        public void Draw(SpriteBatch theSpriteBatch)
        {
            theSpriteBatch.Begin(SpriteBlendMode.AlphaBlend);
            theSpriteBatch.Draw(mEnemyTexture, mEnemy.Destination, mEnemy.Source, Color.White);

           /* foreach (KeyValuePair<string, Sprite.Sprite> mEnemy in mEnemies)
            {

                //If a visible enemy is found, then draw it
                if (mEnemy.Visible == true)
                {
                    theSpriteBatch.Draw(mEnemyTexture, mEnemy.Value.Destination, mEnemy.Value.Source, Color.White);
                }//End if (mEnemy.Value.Visible == true)
            }//Next (KeyValuePair<string, Sprite> mEnemy in mEnemies)*/
            theSpriteBatch.End();
        }//End Draw

        protected enum EnemyState
        {
            Walking,
            Dying
        }//End enemy state

        
       

        protected EnemyState mEnemyState = EnemyState.Walking;
        protected EnemyState CurrentEnemyState
        {
            get
            {
                return mEnemyState;
            }
            set
            {
                mEnemyState = value;
                switch (mEnemyState)
                {
                    case EnemyState.Walking:
                        {
                            mEnemy.TexturePositionX = 4;
                            mEnemy.TexturePositionY = 4;
                            break;
                        }//End Case Walking
                }//End Switch
            }//End Set


        }//End CurrentEnemyState

        protected void UpdateEnemy(double elapsed)
        {
            switch (CurrentEnemyState)
            {
                case EnemyState.Walking:
                    {
                        UpdateEnemyWalking(elapsed);
                        break;
                    }//End Case Walking
            }//End Switch

        }//End UpdateEnemy

        private double mEnemyFootElapsed = 0;
        private void UpdateEnemyWalking(double elapsed)
        {
            mEnemyFootElapsed += elapsed;

            if (mEnemyFootElapsed > 0.4)
            {
                mEnemyFootElapsed = 0;

                if (mEnemy.TexturePositionX == 49)
                {
                    mEnemy.TexturePositionX = 149;
                }
                else
                {
                    mEnemy.TexturePositionX = 49;
                }

            }//End if elapsed > 0.2

            mEnemy.Position = new Vector2(mEnemy.Position.X - 1, mEnemy.Position.Y);
            if (mEnemy.Position.X <= (0 - mEnemy.Width))
            {
                mEnemy.Position = new Vector2(640 + mEnemy.Width, mEnemy.Position.Y);
            }//End if position == 0
        }

        public Sprite.Sprite getEnemy()
        {
            return mEnemy;
        }

        public void reset()
        {
            mEnemy.Position = new Vector2(640 + mEnemy.Width, mEnemy.Position.Y);
        }
    }//End Class
}
