using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Content;
using TheWizard.Sprite;

namespace TheWizard
{
    class LifeCounter
    {
        Texture2D mLifeTexture;

        Sprite.Sprite mLives;
        int lives;

        public LifeCounter(GraphicsDevice theDevice, ContentManager theLoader)
        {
            //Load the image into the texture object
            mLifeTexture = theLoader.Load<Texture2D>("./Images/numbers") as Texture2D;
            mLives = new Sprite.Sprite(new Rectangle(120, 420, 40, 50), new Rectangle(5, 2, 35, 54));
            mLives.Visible = true;
            lives = 0;
        }//End Wizard(GraphicsDevice theDevice)

        public void Draw(SpriteBatch theSpriteBatch)
        {
            theSpriteBatch.Begin(SpriteBlendMode.AlphaBlend);
            checkLives();
            theSpriteBatch.Draw(mLifeTexture, mLives.Destination, mLives.Source, Color.White);

            theSpriteBatch.End();
        }//End Draw

        public void setLives(int num)
        {
            lives = lives + num;
        }

        public int getLives()
        {
            return lives;
        }

        protected void checkLives()
        {
            switch (lives)
            {
                case 1:
                    {
                        mLives.TexturePositionX = 5;
                        mLives.TexturePositionY = 2;
                        break;
                    }//End Case 1
                case 2:
                    {
                        mLives.TexturePositionX = 58;
                        mLives.TexturePositionY = 2;
                        break;
                    }//End Case 2
                case 3:
                    {
                        mLives.TexturePositionX = 114;
                        mLives.TexturePositionY = 2;
                        break;
                    }//End Case 3
            }//end Switch lives
        }

    }
}
