using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

namespace TheWizard.Sprite
{
    class Sprite
    {
        //the X and Y coords

        private Vector2 mPosition;

        public Vector2 Position
        {
            get
            {
                return mPosition;
            }

            set
            {
                mPosition = value;
            }
        }//End of Position property

        //The Start Position of sprite
        Vector2 mStartPosition;
        public Vector2 StartPosition
        {
            get
            {
                return mStartPosition;
            }

            set
            {
                mStartPosition = value;
            }
        }//end startPosition property

        //Width of the Sprite
        private int mWidth;
        public int Width
        {
            get
            {
                return mWidth;
            }
            set
            {
                mWidth = value;
            }
        }//End of Sprite Width

        //Height of the Sprite
        private int mHeight;
        public int Height
        {
            get
            {
                return mHeight;
            }
            set
            {
                mHeight = value;
            }
        }

        //X Position of sprite
        private int mTexturePositionX = 0;
        public int TexturePositionX
        {
            get
            {
                return mTexturePositionX;
            }
            set
            {
                mTexturePositionX = value;
            }
        }

        //Y Position of sprite
        private int mTexturePositionY = 0;
        public int TexturePositionY
        {
            get
            {
                return mTexturePositionY;
            }
            set
            {
                mTexturePositionY = value;
            }
        }
        //The Width of the area in the Texture to be used
        private int mTextureWidth = 0;
        public int TextureWidth
        {
            get
            {
                return mTextureWidth;
            }
            set
            {
                mTextureWidth = value;
            }
        }//End TextureWidth Property

        //The Height of the area in the Texture to be used
        private int mTextureHeight = 0;
        public int TextureHeight
        {
            get
            {
                return mTextureHeight;
            }
            set
            {
                mTextureHeight = value;
            }
        }//End TextureHeight Property

        //Is Sprite Visible?

        private bool mVisible = false;
        public bool Visible
        {
            get
            {
                return mVisible;
            }
            set
            {
                mVisible = value;
            }
        }//End Visible Property

        //Direction
        public enum eDirection
        {
            None,
            Left,
            Right,
            Up,
            Down
        }

        //The Current Direction of the Sprite

        private eDirection mDirection = eDirection.None;
        public eDirection Direction
        {
            get
            {
                return mDirection;
            }
            set
            {
                mDirection = value;
            }
        }//End of Direction Property

        //Where and what size the sprite will be

        public Rectangle Destination
        {
            get
            {
                return new Rectangle((int)Position.X, (int)Position.Y, Width, Height);
            }
        }//End Destination Property

        public Rectangle Source
        {
            get
            {
                return new Rectangle(TexturePositionX, TexturePositionY, TextureWidth, TextureHeight);
            }
        }//End Source property

        //Sprite Constructor
        public Sprite(Rectangle theLocationAndSize, Rectangle theTextureLocationAndSize)
        {
            //store the position, height and width of the sprite
            Position = new Vector2(theLocationAndSize.X, theLocationAndSize.Y);
            Width = theLocationAndSize.Width;
            Height = theLocationAndSize.Height;

            //Store the X and Y position of the texture to be used and its height and width

            TexturePositionX = theTextureLocationAndSize.X;
            TexturePositionY = theTextureLocationAndSize.Y;
            TextureWidth = theTextureLocationAndSize.Width;
            TextureHeight = theTextureLocationAndSize.Height;

            //store the start position of the sprite
            mStartPosition = new Vector2(theLocationAndSize.X, theLocationAndSize.Y);
        }
        int mMass;
        public int Mass
        {
            get 
            {
                return mMass; 
            }

            set 
            {
                mMass = value;
            }
        }

        private Vector2 mVelocity;

        public Vector2 Velocity
        {
            get
            {
                return mVelocity;
            }

            set
            {
                mVelocity = value;
            }
        }//End of Position property

    }
}
