using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Content;
using TheWizard.Sprite;
using TheWizard;

namespace TheWizard
{
    class Terrain
    {
        Texture2D mTerrainTexture;

        Dictionary<string, Sprite.Sprite> mPlatforms = new Dictionary<string, global::TheWizard.Sprite.Sprite>();

        public Terrain(GraphicsDevice theDevice, ContentManager theLoader)
        {
            mTerrainTexture = theLoader.Load<Texture2D>("./Images/Terrain") as Texture2D;

            string aKey = "Platform" + (mPlatforms.Count + 1).ToString();
            mPlatforms.Add(aKey, new Sprite.Sprite(new Rectangle(100,
                270, 100, 20), new Rectangle(3, 2, 102, 17)));
            mPlatforms[aKey].Visible = true;
            /*string bKey = "Platform" + (mPlatforms.Count + 1).ToString();
            mPlatforms.Add(bKey, new Sprite.Sprite(new Rectangle(180,
                170, 100, 20), new Rectangle(3, 2, 102, 17)));
            mPlatforms[bKey].Visible = true;*/
        }

        public void Draw(SpriteBatch theSpriteBatch)
        {
            theSpriteBatch.Begin(SpriteBlendMode.AlphaBlend);

            foreach (KeyValuePair<string, Sprite.Sprite> aPlatform in mPlatforms)
            {
                
                
                    theSpriteBatch.Draw(mTerrainTexture, aPlatform.Value.Destination, aPlatform.Value.Source, Color.White);
                
            }//Next (KeyValuePair<string, Sprite> aPlatform in mPlatforms)
            theSpriteBatch.End();
        }

        public Dictionary<string, Sprite.Sprite> GetPlatforms()
        {
            return mPlatforms;
        }
    }


}
